---
title: DOM onevent handlers
slug: Web/Guide/Events/Event_handlers
tags:
  - Beginner
  - DOM
  - DOM Beginner
  - NeedsBeginnerUpdate
  - NeedsUpdate
---
<p><span class="seoSummary">The Web platform provides several ways to be notified of <a href="/en-US/docs/Web/Events">DOM events</a>. Two common approaches are {{domxref("EventTarget.addEventListener", "addEventListener()")}} and the specific <code>on<em>event</em></code> handlers.</span> This page focuses on how the latter work.</p>

<h2 id="Registering_onevent_handlers">Registering onevent handlers</h2>

<p>The <strong><code>on<em>event</em></code></strong> handlers are properties on certain DOM elements to manage how that element reacts to events. Elements can be interactive (links, buttons, images, forms, and so forth) or non-interactive (such as the base <code>&lt;body&gt;</code> element). Events are actions like:</p>

<ul>
 <li>Being clicked</li>
 <li>Detecting pressed keys</li>
 <li>Getting focus</li>
</ul>

<p>The <code>on<em>event</em></code> handler is usually named with the event it reacts to, like <code>on<em>click</em></code>, <code>on<em>keypress</em></code>, <code>on<em>focus</em></code>, etc.</p>

<p>You can specify an <code>on<em>&lt;…&gt;</em></code> event handler for a particular event (such as {{event("click")}}) for a given object in different ways:</p>

<ul>
 <li>Adding an HTML {{Glossary("attribute")}} named <code>on<em>&lt;eventtype&gt;</em></code>:<br>
  <code>&lt;button <strong>onclick="handleClick()"</strong>&gt;</code>,</li>
 <li>Or by setting the corresponding {{Glossary("property/JavaScript", "property")}} from JavaScript:<br>
  <code>document.querySelector("button")<strong>.onclick = function(event) { … }</strong></code>.</li>
</ul>

<p>An <code>on<em>event</em></code> event handler property serves as a placeholder of sorts, to which a single event handler can be assigned. In order to allow multiple handlers to be installed for the same event on a given object, you can call its {{domxref("EventTarget.addEventListener", "addEventListener()")}} method, which manages a list of handlers for the given event on the object. A handler can then be removed from the object by calling its {{domxref("EventTarget.removeEventListener", "removeEventListener()")}} function.</p>

<p>When an event occurs that applies to an element, each of its event handlers is called to allow them to handle the event, one after another. You don't need to call them yourself, although you can do so in many cases to easily simulate an event taking place. For example, given a button object <code>myButton</code>, you can do <code>myButton.onclick(myEventObject)</code> to call the event handler directly. If the event handler doesn't access any data from the event object, you can leave out the event when calling <code>onclick()</code>.</p>

<p>This continues until every handler has been called, unless one of the event handlers explicitly halts the processing of the event by calling {{domxref("Event.stopPropagation", "stopPropagation()")}} on the event object itself.</p>

<h3 id="Non-element_objects">Non-element objects</h3>

<p>Event handlers can also be set with properties on non-element objects that generate events, like {{ domxref("window") }}, {{ domxref("document") }}, {{ domxref("XMLHttpRequest") }}, and others. For example, for the <code>progress</code> event on instances of <code>XMLHttpRequest</code>:</p>

<pre class="brush: js notranslate">const xhr = new XMLHttpRequest();
xhr.onprogress = function() { … };</pre>

<h2 id="HTML_onevent_attributes">HTML onevent attributes</h2>

<p>HTML elements have attributes named <code>on<em>event</em></code> which can be used to register a handler for an event directly within the HTML code. When the element is built from the HTML, the value of its <code>on<em>event</em></code> attributes are copied to the DOM object that represents the element, so that accessing the attributes' values using JavaScript will get the value set in the HTML.</p>

<p>Further changes to the HTML attribute value can be done via the {{domxref("Element/setAttribute", "setAttribute")}} method; Making changes to the JavaScript property will have no effect.</p>

<h3 id="HTML">HTML</h3>

<p>Given this HTML document:</p>

<pre class="brush: html notranslate">&lt;p&gt;Demonstrating quirks of &lt;code&gt;on&lt;em&gt;event&lt;/em&gt;&lt;/code&gt; HTML attributes on
   &lt;a onclick="log('Click!')"&gt;these three words&lt;/a&gt;.
&lt;/p&gt;

&lt;div&gt;&lt;/div&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<p>Then this JavaScript demonstrates that the value of the HTML attribute is unaffected by changes to the JavaScript object's property.</p>

<pre class="brush: js notranslate">let logElement = document.querySelector('div');
let el = document.querySelector("a");

function log(msg) { logElement.innerHTML += `${msg}&lt;br&gt;` };
function anchorOnClick(event) { log("Changed onclick handler") };

// Original Handler
log(`Element's onclick as a JavaScript property: &lt;code&gt; ${el.onclick.toString()} &lt;/code&gt;`);

//Changing handler using .onclick
log('&lt;br&gt;Changing onclick handler using &lt;strong&gt; onclick property &lt;/strong&gt; ');

el.onclick = anchorOnClick;

log(`Changed the property to: &lt;code&gt; ${el.onclick.toString()} &lt;/code&gt;`);
log(`But the HTML attribute is unchanged: &lt;code&gt; ${el.getAttribute("onclick")} &lt;/code&gt;&lt;br&gt;`);

//Changing handler using .setAttribute
log('&lt;hr/&gt;&lt;br&gt; Changing onclick handler using &lt;strong&gt; setAttribute method &lt;/strong&gt; ');
el.setAttribute("onclick", 'anchorOnClick(event)');

log(`Changed the property to: &lt;code&gt; ${el.onclick.toString()} &lt;/code&gt;`);
log(`Now even the HTML attribute has changed: &lt;code&gt; ${el.getAttribute("onclick")} &lt;/code&gt;&lt;br&gt;`);</pre>

<h3 id="Result">Result</h3>

<p>{{ EmbedLiveSample('HTML_onevent_attributes', '', '', '', 'Web/Guide/Events/Event_handlers') }}</p>

<p>For historical reasons, some attributes/properties on the {{HTMLElement("body")}} and {{HTMLElement("frameset")}} elements instead set event handlers on their parent {{domxref("Window")}} object. (The HTML specification names these: {{domxref("GlobalEventHandlers/onblur", "onblur")}}, {{domxref("GlobalEventHandlers/onerror", "onerror")}}, {{domxref("GlobalEventHandlers/onfocus", "onfocus")}}, {{domxref("GlobalEventHandlers/onload", "onload")}}, and {{domxref("GlobalEventHandlers/onscroll", "onscroll")}}.)</p>

<h3 id="Event_handlers_parameters_this_binding_and_the_return_value">Event handler's parameters, this binding, and the return value</h3>

<p>When the event handler is specified as <strong>an HTML attribute</strong>, the specified code is wrapped into a function with <strong>the following parameters</strong>:</p>

<ul>
 <li><code>event</code> — for all event handlers except {{domxref("GlobalEventHandlers.onerror", "onerror")}}.</li>
 <li><code>event</code>, <code>source</code>, <code>lineno</code>, <code>colno</code>, and <code>error</code> for the {{domxref("GlobalEventHandlers.onerror", "onerror")}} event handler. Note that the <code>event</code> parameter actually contains the error message as a string.</li>
</ul>

<p>When the event handler is invoked, the <code>this</code> keyword inside the handler is set to the DOM element on which the handler is registered. For more details, see <a href="/en-US/docs/Web/JavaScript/Reference/Operators/this#In_an_inline_event_handler">the <code>this</code> keyword documentation</a>.</p>

<p>The return value from the handler determines if the event is canceled. The specific handling of the return value depends on the kind of event; for details, see <a href="https://html.spec.whatwg.org/multipage/webappapis.html#the-event-handler-processing-algorithm">"The event handler processing algorithm" in the HTML specification</a>.</p>

<h3 id="When_the_event_handler_is_invoked">When the event handler is invoked</h3>

<div class="notecard note">
<p>TBD (non-capturing listener)</p>
</div>

<h3 id="Terminology">Terminology</h3>

<p>The term <strong>event handler</strong> may refer to:</p>

<ul>
 <li>Any function or object that is registered to be notified of events</li>
 <li>Or more specifically, to the mechanism of registering event listeners via <code>on…</code> attributes in HTML or properties in Web APIs, such as <code>&lt;button onclick="alert(this)"&gt;</code> or <code>window.onload = function() { … }</code>.</li>
</ul>

<p>When discussing the various methods of listening to events:</p>

<ul>
 <li><strong>Event listener</strong> refers to a function or object registered via {{domxref("EventTarget.addEventListener()")}}</li>
 <li><strong>Event handler</strong> refers to a function registered via <code>on…</code> attributes or properties</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'webappapis.html#event-handler-attributes', 'event handlers')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'webappapis.html#event-handler-attributes', 'event handlers')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser compatibility</h2>

<h4 id="Detecting_the_presence_of_event_handler_properties">Detecting the presence of event handler properties</h4>

<p>You can detect the presence of an event handler property with the JavaScript {{jsxref("Operators/in", "in")}} operator. For example:</p>

<pre class="brush: js notranslate">if ("onsomenewfeature" in window) {
  /* do something amazing */
}
</pre>

<h4 id="Event_handlers_and_prototypes">Event handlers and prototypes</h4>

<p>You can't set or access the values of any IDL-defined attributes on DOM prototype objects. That means you can't, for example, change <code>Window.prototype.onload</code>. In the past, event handlers (<code>onload</code>, etc.) weren't implemented as IDL attributes in Gecko, so you were able to do this for those. Now you can't. This improves compatibility.</p>
